<?php
/**
* @version		$Id: plg_com_fireboard.php,v 1.2 2008/04/13 22:31:20 pythontech Exp $
* @package		pt_smartsef_fireboard
* @subpackage	Admin
* @copyright	Copyright 2008 Python Technology Ltd
* @license		GNU/GPL, see LICENSE.php
*
*/

/*-----------------------------------------------------------------------
 *	Convert non-SEF URLs produced by fireboard
 *	All have ?option=com_fireboard&Itemid=35
 *-----------------------------------------------------------------------*/
function FireboardBuildRoute($query)
{
  global $_fireboard_alias;
  $db =& JFactory::getDBO();
  $qu = $query;
  $segments = array();
  /*-- Fetch the parameter settings for the plugin.  Use global alias parameter to avoid multiple sql queries */
  if ($_fireboard_alias == NULL) {
	$sql = "SELECT params FROM #__smartsef_plugins WHERE plugin='plg_com_fireboard'" ;
	$db->setQuery($sql);
	$params = $db->loadResult();
	if ($params != NULL) {
	  $params = new JParameter($params);
	  $_fireboard_alias = $params->get('url_prefix_path');
	}
  }
  if ($_fireboard_alias != NULL) {
	$segments[] = $_fireboard_alias;
  } else {
	/*--- Default prefix is 'forum' */
	$segments[] = 'forum';
  }

  $func = _ptseffb_get($qu,'func');
  if ($func == '') {
    $task = _ptseffb_get($qu,'task');
    if ($task == 'listcat') {
      $segments[] = 'forum'._ptseffb_get($qu,'catid');
      $segments[] = 'list';
    } elseif ($task != '') {
      $segments[] = $task;
    }

  } elseif ($func == 'listcat') {
    // Weirdly, fireboard uses both task=listcat and func=listcat
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $segments[] = 'list';

  } elseif ($func == 'view') {
    // View a topic
    //   func=view&id=1&catid=3
    //   func=view&id=5&view=flat&catid=3
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $segments[] = 'msg'._ptseffb_get($qu,'id');
    $view = _ptseffb_get($qu,'view');
    if ($view != '') {
      $segments[] = $view;
    }

  } elseif ($func == 'showcat') {
    // Show category
    //   func=showcat&catid=3
    //   func=showcat&id=0&view=threadedview&catid=3
    $view = _ptseffb_get($qu,'view');
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $id = _ptseffb_get($qu,'id','0');
    if ($id != '0') {
      $segments[] = 'msg'.$id;
    }
    $page = _ptseffb_get($qu,'page','1');
    if ($page != '1') {
      $segments[] = 'page'.$page;
    }
    if ($view == 'threadedview') {
      $segments[] = 'threaded';
    }

  } elseif ($func == 'fb_pdf') {
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $segments[] = 'msg'._ptseffb_get($qu,'id').'.pdf';

  } elseif ($func == 'markThisRead') {
    //   func=markThisRead&catid=3
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $segments[] = 'markthisread';

  } elseif ($func == 'latest') {
    // List of recent posts
    //   func=latest
    //   func=latest&do=show&sel=12
    $segments[] = $func;
    $do = _ptseffb_get($qu,'do');
    if ($do == 'show') {
      $sel = _ptseffb_get($qu,'sel');
      if ($sel == '0') {
	$segments[] = 'session';
      } else {
	$segments[] = $sel.'hour';
      }
    } elseif ($do != '') {
      $segments[] = $do;
    }

  } elseif ($func == 'userlist') {
    // Lists of users
    //   func=userlist
    //   func=userlist&orderby=name&direction=ASC
    $segments[] = $func;
    $orderby = _ptseffb_get($qu,'orderby');
    if ($orderby != '') {
      $direction = _ptseffb_get($qu,'direction','ASC');
      if ($direction == 'ASC') {
	$segments[] = $orderby;
      } else {
	// DESC
	$segments[] = '-'.$orderby;
      }
    }

  } elseif ($func == 'rules' or
	    $func == 'faq' or
	    $func == 'userlist' or
	    $func == 'stats' or
	    $func == 'who') {
    // Top-level special views
    $segments[] = $func;

  } elseif ($func == 'myprofile') {
    // Profile, maybe editable
    //   func=myprofile&do=show
    $segments[] = $func;
    $do = _ptseffb_get($qu,'do');
    if ($do == 'show') {
    } else {
      $segments[] = $do;
    }

  } elseif ($func == 'announcement') {
    // Announcement, maybe editable
    //   func=announcement&do=show
    $segments[] = $func;
    $do = _ptseffb_get($qu,'do');
    if ($do == 'show' or $do == '') {
    } else {
      $segments[] = $do;
    }
	  
  } elseif ($func == 'fbprofile') {
    // (Other) user's profile
    //   func=fbprofile&task=showprf&userid=67
    $segments[] = 'user'._ptseffb_get($qu,'userid');
    $task = _ptseffb_get($qu,'task');
    if ($task == 'showprf') {
    } else {
      $segments[] = $task;
    }

  } elseif ($func == 'post') {
    // Post message or modify existing
    //   func=post&do=reply&catid=3	Post New Topic
    //   func=post&do=reply&replyto=2	Reply
    //   func=post&do=quote&replyto=2	Quote
    //   func=post&do=XXX&id=2&catid=3	Edit / (un)sticky / (un)lock / delete
    $do = _ptseffb_get($qu,'do');
    if ($do == '') {
      //   func=post
      $segments[] = $func;
    } elseif ($do == 'reply' or
	$do == 'quote') {
      $catid = _ptseffb_get($qu,'catid');
      if ($catid != '') {
	$segments[] = 'forum'.$catid;
      }
      $id = _ptseffb_get($qu,'replyto','0');
      if ($id == '0') {
	// New post
      } else {
	$segments[] = 'msg'.$id;
      }
      $segments[] = $do;
    } elseif ($do == 'edit' or
	      $do == 'delete' or
	      $do == 'sticky' or
	      $do == 'unsticky' or
	      $do == 'lock' or
	      $do == 'unlock') {
      // Operations on message
      $segments[] = 'forum'._ptseffb_get($qu,'catid');
      $segments[] = 'msg'._ptseffb_get($qu,'id');
      $segments[] = $do;
    } elseif ($do == 'favorite' or
	      $do == 'subscribe') {
      $segments[] = 'forum'._ptseffb_get($qu,'catid');
      $segments[] = 'msg'._ptseffb_get($qu,'fb_thread');
      $segments[] = $do;
      _ptseffb_get($qu,'id');
    } elseif ($do == 'move') {
      //   func=post&do=move&id=2&catid=3&name=colinhogben
      $segments[] = 'forum'._ptseffb_get($qu,'catid');
      $segments[] = 'msg'._ptseffb_get($qu,'id');
      $segments[] = $do;
      _ptseffb_get($qu,'name');
    } else {
      $segments[] = $do;
    }

  } elseif ($func == 'report') {
    // Report item to moderator
    //   func=report&msg_id=2&catid=3
    $segments[] = 'forum'._ptseffb_get($qu,'catid');
    $segments[] = 'msg'._ptseffb_get($qu,'msg_id');
    $segments[] = 'report';

  } else {
    // Default for unknown functions
    $segments[] = $func;
  }

  /*--- Append any other guff */
  _ptseffb_get($qu,'option');
  _ptseffb_get($qu,'Itemid');
  if (isset($qu)) {
    foreach ($qu as $param => $value) {
      $segments[] = $param.'-'.$value;
    }
  }

  return $segments;
}

function _ptseffb_get(&$arr,$key,$dflt='')
{
  if (array_key_exists($key,$arr)) {
    $value = $arr[$key];
    unset($arr[$key]);
  } else {
    $value = $dflt;
  }
  return $value;
}

?>
